4d56ae405851eb5a1c7f112284e0c3ecc3cbf73b
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 96, 1997 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash db tcl tk tclX itcl"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 # Note, the powerpc-eabi build depends on sim occurring before gdb in order to
52 # know that we are building the simulator.
53 host_tools="texinfo byacc flex bison binutils ld gas gcc sim gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils sn"
54
55
56 # these libraries are built for the target environment, and are built after
57 # the host libraries and the host tools (which may be a cross compiler)
58 #
59 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
60
61
62 # these tools are built using the target libs, and are intended to run only
63 # in the target environment
64 #
65 # note: any program that *uses* libraries that are in the "target_libs"
66 # list belongs in this list. those programs are also very likely
67 # candidates for the "native_only" list which follows
68 #
69 target_tools="target-examples target-groff"
70
71 ################################################################################
72
73 ## These two lists are of directories that are to be removed from the
74 ## ${configdirs} list for either cross-compilations or for native-
75 ## compilations. For example, it doesn't make that much sense to
76 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
77 ## a native environment.
78
79 # directories to be built in the native environment only
80 #
81 # This must be a single line because of the way it is searched by grep in
82 # the code below.
83 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms sn"
84
85 # directories to be built in a cross environment only
86 #
87 cross_only="target-libiberty target-libgloss target-newlib"
88
89 ## All tools belong in one of the four categories, and are assigned above
90 ## We assign ${configdirs} this way to remove all embedded newlines. This
91 ## is important because configure will choke if they ever get through.
92 ## ${configdirs} is directories we build using the host tools.
93 ## ${target_configdirs} is directories we build using the target tools.
94 #
95 configdirs=`echo ${host_libs} ${host_tools}`
96 target_configdirs=`echo ${target_libs} ${target_tools}`
97
98 ################################################################################
99
100 srctrigger=move-if-change
101 srcname="gnu development package"
102
103 # This gets set non-empty for some net releases of packages.
104 appdirs=""
105
106 # per-host:
107
108 # Work in distributions that contain no compiler tools, like Autoconf.
109 if [ -d ${srcdir}/config ]; then
110 case "${host}" in
111 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
112 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
113 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
114 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
115 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
116 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
117 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
118 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
119 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
120 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
121 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
122 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
123 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
124 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
125 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
126 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
127 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
128 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
129 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
130 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
131 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
132 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
133 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
134 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
135 *-windows*) host_makefile_frag=config/mh-windows ;;
136 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
137 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
138 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
139 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
140 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
141 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
142 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
143 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
144 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
145 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
146 esac
147 fi
148
149 # If we aren't going to be using gcc, see if we can extract a definition
150 # of CC from the fragment.
151 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
152 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
153 found=
154 for dir in $PATH; do
155 test -z "$dir" && dir=.
156 if test -f $dir/gcc; then
157 found=yes
158 break
159 fi
160 done
161 IFS="$save_ifs"
162 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
163 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
164 if [ -n "${xx}" ] ; then
165 CC=$xx
166 fi
167 fi
168 fi
169
170 # We default to --with-shared on platforms where -fpic is meaningless.
171 # Well, we don't yet, but we will.
172 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
173 case "${target}" in
174 alpha-dec-osf*) enable_shared=yes ;;
175 alpha-*-linux*) enable_shared=yes ;;
176 mips-sgi-irix5*) enable_shared=yes ;;
177 *) enable_shared=no ;;
178 esac
179 fi
180
181 case "${enable_shared}" in
182 yes) shared=yes ;;
183 no) shared=no ;;
184 "") shared=no ;;
185 *) shared=yes ;;
186 esac
187
188 if [ x${shared} = xyes ]; then
189 waugh=
190 case "${host}" in
191 hppa*) waugh=config/mh-papic ;;
192 i[3456]86-*) waugh=config/mh-x86pic ;;
193 sparc64-*) waugh=config/mh-sparcpic ;;
194 *) waugh=config/mh-${host_cpu}pic ;;
195 esac
196 if [ -f ${srcdir}/${waugh} ]; then
197 if [ -n "${host_makefile_frag}" ] ; then
198 cat ${srcdir}/${host_makefile_frag} > mh-frag
199 cat ${srcdir}/${waugh} >> mh-frag
200 host_makefile_frag=mh-frag
201 else
202 host_makefile_frag=${waugh}
203 fi
204 fi
205 fi
206
207 # per-target:
208
209 case "${target}" in
210 v810*) target_makefile_frag=config/mt-v810 ;;
211 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
212 # start-sanitize-r5900
213 mips64vr5900*-*-*) target_makefile_frag=config/mt-r5900 ;;
214 # end-sanitize-r5900
215 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
216 esac
217
218 skipdirs=
219 gasdir=gas
220 use_gnu_ld=
221 use_gnu_as=
222
223 # some tools are so dependent upon X11 that if we're not building with X,
224 # it's not even worth trying to configure, much less build, that tool.
225
226 case ${with_x} in
227 yes | "") # the default value for this tree is that X11 is available
228 ;;
229 no)
230 skipdirs="${skipdirs} tk gash"
231 ;;
232 *)
233 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
234 ;;
235 esac
236
237 # Some tools are only suitable for building in a "native" situation.
238 # Those are added when we have a host==target configuration. For cross
239 # toolchains, we add some directories that should only be useful in a
240 # cross-compiler.
241
242 is_cross_compiler=
243
244 if [ x"${host}" = x"${target}" ] ; then
245 # when doing a native toolchain, don't build the targets
246 # that are in the 'cross only' list
247 skipdirs="${skipdirs} ${cross_only}"
248 is_cross_compiler=no
249 target_subdir=.
250 else
251 # similarly, don't build the targets in the 'native only'
252 # list when building a cross compiler
253 skipdirs="${skipdirs} ${native_only}"
254 is_cross_compiler=yes
255 target_subdir=${target_alias}
256 if [ ! -d ${target_subdir} ] ; then
257 if mkdir ${target_subdir} ; then true
258 else
259 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
260 exit 1
261 fi
262 fi
263 fi
264
265 copy_dirs=
266
267 # Handle --with-headers=XXX. The contents of the named directory are
268 # copied to $(tooldir)/sys-include.
269 if [ x"${with_headers}" != x ]; then
270 if [ x${is_cross_compiler} = xno ]; then
271 echo 1>&2 '***' --with-headers is only supported when cross compiling
272 exit 1
273 fi
274 case "${exec_prefixoption}" in
275 "") x=${prefix} ;;
276 *) x=${exec_prefix} ;;
277 esac
278 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
279 fi
280
281 # Handle --with-libs=XXX. Multiple directories are permitted. The
282 # contents are copied to $(tooldir)/lib.
283 if [ x"${with_libs}" != x ]; then
284 if [ x${is_cross_compiler} = xno ]; then
285 echo 1>&2 '***' --with-libs is only supported when cross compiling
286 exit 1
287 fi
288 # Copy the libraries in reverse order, so that files in the first named
289 # library override files in subsequent libraries.
290 case "${exec_prefixoption}" in
291 "") x=${prefix} ;;
292 *) x=${exec_prefix} ;;
293 esac
294 for l in ${with_libs}; do
295 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
296 done
297 fi
298
299 # If both --with-headers and --with-libs are specified, default to
300 # --without-newlib.
301 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
302 if [ x"${with_newlib}" = x ]; then
303 with_newlib=no
304 fi
305 fi
306
307 # Recognize --with-newlib/--without-newlib.
308 if [ x${with_newlib} = xno ]; then
309 skipdirs="${skipdirs} target-newlib"
310 elif [ x${with_newlib} = xyes ]; then
311 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
312 fi
313
314 # Default to using --with-stabs for certain targets.
315 if [ x${with_stabs} = x ]; then
316 case "${target}" in
317 mips*-*-irix6*)
318 ;;
319 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
320 with_stabs=yes;
321 withoptions="${withoptions} --with-stabs"
322 ;;
323 esac
324 fi
325
326 # Handle ${copy_dirs}
327 set fnord ${copy_dirs}
328 shift
329 while [ $# != 0 ]; do
330 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
331 :
332 else
333 echo Copying $1 to $2
334
335 # Use the install script to create the directory and all required
336 # parent directories.
337 if [ -d $2 ]; then
338 :
339 else
340 echo >config.temp
341 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
342 fi
343
344 # Copy the directory, assuming we have tar.
345 # FIXME: Should we use B in the second tar? Not all systems support it.
346 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
347
348 # It is the responsibility of the user to correctly adjust all
349 # symlinks. If somebody can figure out how to handle them correctly
350 # here, feel free to add the code.
351
352 echo $1 > $2/COPIED
353 fi
354 shift; shift
355 done
356
357 # Configure extra directories which are host specific
358
359 case "${host}" in
360 i[3456]86-*-go32*)
361 configdirs="$configdirs dosrel" ;;
362 *-cygwin32*)
363 configdirs="$configdirs dosrel" ;;
364 esac
365
366 # Remove more programs from consideration, based on the host or
367 # target this usually means that a port of the program doesn't
368 # exist yet.
369
370 noconfigdirs=""
371
372 case "${host}" in
373 i[3456]86-*-vsta)
374 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl db sn"
375 ;;
376 i[3456]86-*-go32)
377 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl db sn"
378 ;;
379 *-*-cygwin32)
380 noconfigdirs="expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet itcl db sn"
381 ;;
382 *-*-windows*)
383 # This is only used to build WinGDB...
384 configdirs="bfd gdb libiberty opcodes readline sim"
385 target_configdirs=
386 ;;
387 ppc*-*-pe)
388 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet itcl db sn"
389 ;;
390 esac
391
392
393 case "${target}" in
394 *-*-netware)
395 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
396 ;;
397 *-*-vxworks*)
398 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
399 ;;
400 alpha-dec-osf*)
401 # ld works, but does not support shared libraries. emacs doesn't
402 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
403 # gas doesn't generate exception information.
404 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
405 ;;
406 alpha*-*-*vms*)
407 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
408 ;;
409 alpha*-*-*)
410 # newlib is not 64 bit ready
411 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
412 ;;
413 # start-sanitize-arc
414 arc-*-*)
415 noconfigdirs="$noconfigdirs target-libgloss"
416 ;;
417 # end-sanitize-arc
418 arm-*-pe*)
419 noconfigdirs="$noconfigdirs target-libgloss"
420 ;;
421 arm-*-coff*)
422 noconfigdirs="$noconfigdirs target-libgloss"
423 ;;
424 arm-*-riscix*)
425 noconfigdirs="$noconfigdirs ld target-libgloss"
426 ;;
427 d10v-*-*)
428 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
429 ;;
430 # start-sanitize-d30v
431 d30v-*-*)
432 noconfigdirs="$noconfigdirs tcl tk expect gcc gdb newlib target-librx target-libg++ target-libstdc++ target-libio target-libgloss itcl db sn target-libiberty target-newlib target-examples"
433 ;;
434 # end-sanitize-d30v
435 h8300*-*-* | \
436 h8500-*-*)
437 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
438 ;;
439 hppa*-*-*elf* | \
440 hppa*-*-lites* | \
441 hppa*-*-rtems* )
442 # Do configure ld/binutils/gas for this case.
443 ;;
444 hppa*-*-*)
445 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
446 # cc is gcc, and on any system a user should be able to link cc to
447 # whatever they want. FIXME, emacs emacs19).
448 case "${CC}" in
449 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
450 *) ;;
451 esac
452 noconfigdirs="$noconfigdirs ld shellutils"
453 ;;
454 i[3456]86-*-go32)
455 # but don't build gdb
456 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
457 ;;
458 *-*-cygwin32)
459 target_configdirs="$target_configdirs target-winsup"
460 noconfigdirs="$noconfigdirs expect target-libgloss itcl db sn"
461 # always build newlib.
462 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
463
464 # Can't build gdb for cygwin32 if not native.
465 case "${host}" in
466 *-*-cygwin32) ;; # keep gdb
467 *) noconfigdirs="$noconfigdirs gdb"
468 esac
469 ;;
470 i[3456]86-*-pe)
471 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
472 ;;
473 i[3456]86-*-sco3.2v5*)
474 # The linker does not yet know about weak symbols in COFF,
475 # and is not configured to handle mixed ELF and COFF.
476 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
477 ;;
478 i[3456]86-*-sco*)
479 noconfigdirs="$noconfigdirs gprof target-libgloss"
480 ;;
481 i[3456]86-*-solaris2*)
482 # The linker does static linking correctly, but the Solaris C library
483 # has bugs such that some important functions won't work when statically
484 # linked. (See man pages for getpwuid, for example.)
485 noconfigdirs="$noconfigdirs ld target-libgloss"
486 ;;
487 i[3456]86-*-sysv4*)
488 # The SYSV4 C compiler doesn't handle Emacs correctly
489 case "${CC}" in
490 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
491 *) ;;
492 esac
493 # but that's okay since emacs doesn't work anyway
494 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
495 ;;
496 mn10200-*-*)
497 noconfigdirs="$noconfigdirs target-libgloss"
498 ;;
499 mn10300-*-*)
500 noconfigdirs="$noconfigdirs target-libgloss"
501 ;;
502 powerpc-*-aix*)
503 # copied from rs6000-*-* entry
504 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
505 # This is needed until gcc and ld are fixed to work together.
506 use_gnu_ld=no
507 ;;
508 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
509 target_configdirs="$target_configdirs target-winsup"
510 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss itcl db sn"
511 # always build newlib.
512 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
513 ;;
514 # This is temporary until we can link against shared libraries
515 powerpcle-*-solaris*)
516 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect itcl db sn"
517 ;;
518 rs6000-*-lynxos*)
519 # The CVS server code doesn't work on the RS/6000
520 # Newlib makes problems for libg++ in crosses.
521 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
522 ;;
523 rs6000-*-aix*)
524 noconfigdirs="$noconfigdirs gprof"
525 # This is needed until gcc and ld are fixed to work together.
526 use_gnu_ld=no
527 ;;
528 rs6000-*-*)
529 noconfigdirs="$noconfigdirs gprof"
530 ;;
531 m68k-apollo-*)
532 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
533 ;;
534 mips*-*-irix5*)
535 # The GNU linker does not support shared libraries.
536 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
537 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
538 ;;
539 mips*-*-irix6*)
540 # The GNU linker does not support shared libraries.
541 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
542 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
543 ;;
544 mips*-dec-bsd*)
545 noconfigdirs="$noconfigdirs gprof target-libgloss"
546 ;;
547 mips*-*-bsd*)
548 noconfigdirs="$noconfigdirs gprof target-libgloss"
549 ;;
550 mips*-*-*)
551 noconfigdirs="$noconfigdirs gprof"
552 ;;
553 romp-*-*)
554 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
555 ;;
556 sh-*-*)
557 case "${host}" in
558 i[3456]86-*-vsta) ;; # don't add gprof back in
559 i[3456]86-*-go32) ;; # don't add gprof back in
560 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
561 esac
562 noconfigdirs="$noconfigdirs target-libgloss"
563 ;;
564 sparc-*-sunos4*)
565 if [ x${is_cross_compiler} != xno ] ; then
566 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
567 else
568 use_gnu_ld=no
569 fi
570 ;;
571 v810-*-*)
572 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
573 ;;
574 # start-sanitize-v850
575 v850-*-*)
576 noconfigdirs="$noconfigdirs target-libgloss"
577 ;;
578 # end-sanitize-v850
579 vax-*-vms)
580 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
581 ;;
582 vax-*-*)
583 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
584 ;;
585 *-*-lynxos*)
586 # Newlib makes problems for libg++ in crosses.
587 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
588 ;;
589 *-*-macos* | \
590 *-*-mpw*)
591 # Macs want a resource compiler.
592 configdirs="$configdirs grez"
593 ;;
594 esac
595
596 # targets that need a second pass
597 case "${target}" in
598 *-gm-magic*)
599 noconfigdirs="$noconfigdirs target-libgloss"
600 ;;
601 esac
602
603 # If we aren't building newlib, then don't build libgloss, since libgloss
604 # depends upon some newlib header files.
605 case "${noconfigdirs}" in
606 *target-libgloss*) ;;
607 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
608 esac
609
610 # If we are building a Canadian Cross, discard tools that can not be built
611 # using a cross compiler. FIXME: These tools should be fixed.
612 if [ "${build}" != "${host}" ]; then
613 noconfigdirs="$noconfigdirs expect dejagnu itcl db sn"
614 fi
615
616 # Make sure we don't let GNU ld be added if we didn't want it.
617 if [ x$with_gnu_ld = xno ]; then
618 use_gnu_ld=no
619 noconfigdirs="$noconfigdirs ld"
620 fi
621
622 # Make sure we don't let GNU as be added if we didn't want it.
623 if [ x$with_gnu_as = xno ]; then
624 use_gnu_as=no
625 noconfigdirs="$noconfigdirs gas"
626 fi
627
628 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
629 # $target_configdirs.
630 # If we have the source for $noconfigdirs entries, add them to $notsupp.
631
632 notsupp=""
633 for dir in . $skipdirs $noconfigdirs ; do
634 dirname=`echo $dir | sed -e s/target-//g`
635 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
636 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
637 if [ -r $srcdir/$dirname/configure ] \
638 || [ -r $srcdir/$dirname/configure.in ]; then
639 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
640 true
641 else
642 notsupp="$notsupp $dir"
643 fi
644 fi
645 fi
646 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
647 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
648 if [ -r $srcdir/$dirname/configure ] \
649 || [ -r $srcdir/$dirname/configure.in ]; then
650 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
651 true
652 else
653 notsupp="$notsupp $dir"
654 fi
655 fi
656 fi
657 done
658
659 # Sometimes the tools are distributed with libiberty but with no other
660 # libraries. In that case, we don't want to build target-libiberty.
661 if [ -n "${target_configdirs}" ]; then
662 others=
663 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
664 if [ "$i" != "libiberty" ]; then
665 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
666 others=yes;
667 break;
668 fi
669 fi
670 done
671 if [ -z "${others}" ]; then
672 target_configdirs=
673 fi
674 fi
675
676 # Deconfigure all subdirectories, in case we are changing the
677 # configuration from one where a subdirectory is supported to one where it
678 # is not.
679 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
680 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
681 rm -f $i/Makefile
682 done
683 fi
684 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
685 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
686 rm -f ${target_subdir}/$i/Makefile
687 done
688 fi
689
690 # Produce a warning message for the subdirs we can't configure.
691 # This isn't especially interesting in the Cygnus tree, but in the individual
692 # FSF releases, it's important to let people know when their machine isn't
693 # supported by the one or two programs in a package.
694
695 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
696 # If $appdirs is non-empty, at least one of those directories must still
697 # be configured, or we error out. (E.g., if the gas release supports a
698 # specified target in some subdirs but not the gas subdir, we shouldn't
699 # pretend that all is well.)
700 if [ -n "$appdirs" ]; then
701 for dir in $appdirs ; do
702 if [ -r $dir/Makefile.in ]; then
703 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
704 appdirs=""
705 break
706 fi
707 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
708 appdirs=""
709 break
710 fi
711 fi
712 done
713 if [ -n "$appdirs" ]; then
714 echo "*** This configuration is not supported by this package." 1>&2
715 exit 1
716 fi
717 fi
718 # Okay, some application will build, or we don't care to check. Still
719 # notify of subdirs not getting built.
720 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
721 echo " ${notsupp}" 1>&2
722 echo " (Any other directories should still work fine.)" 1>&2
723 fi
724
725 # Set with_gnu_as and with_gnu_ld as appropriate.
726 #
727 # This is done by determining whether or not the appropriate directory
728 # is available, and by checking whether or not specific configurations
729 # have requested that this magic not happen.
730 #
731 # The command line options always override the explicit settings in
732 # configure.in, and the settings in configure.in override this magic.
733 #
734 # If the default for a toolchain is to use GNU as and ld, and you don't
735 # want to do that, then you should use the --without-gnu-as and
736 # --without-gnu-ld options for the configure script.
737
738 if [ x${use_gnu_as} = x ] ; then
739 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
740 with_gnu_as=yes
741 withoptions="$withoptions --with-gnu-as"
742 fi
743 fi
744
745 if [ x${use_gnu_ld} = x ] ; then
746 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
747 with_gnu_ld=yes
748 withoptions="$withoptions --with-gnu-ld"
749 fi
750 fi
751
752 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
753 # can detect this case.
754
755 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
756 with_newlib=yes
757 withoptions="$withoptions --with-newlib"
758 fi
759
760 if [ x${shared} = xyes ]; then
761 case "${target}" in
762 hppa*) target_makefile_frag=config/mt-papic ;;
763 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
764 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
765 esac
766 fi
767
768 # post-target:
769
770 # Make sure that the compiler is able to generate an executable. If it
771 # can't, we are probably in trouble. We don't care whether we can run the
772 # executable--we might be using a cross compiler--we only care whether it
773 # can be created. At this point the main configure script has set CC.
774 echo "int main () { return 0; }" > conftest.c
775 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
776 if [ $? = 0 ] && [ -s conftest ]; then
777 :
778 else
779 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
780 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
781 rm -f conftest*
782 exit 1
783 fi
784 rm -f conftest*
785
786 # The Solaris /usr/ucb/cc compiler does not appear to work.
787 case "${host}" in
788 sparc-sun-solaris2*)
789 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
790 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
791 could_use=
792 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
793 if [ -d /opt/cygnus/bin ] ; then
794 if [ "$could_use" = "" ] ; then
795 could_use="/opt/cygnus/bin"
796 else
797 could_use="$could_use or /opt/cygnus/bin"
798 fi
799 fi
800 if [ "$could_use" = "" ] ; then
801 echo "Warning: compilation may fail because you're using"
802 echo "/usr/ucb/cc. You should change your PATH or CC "
803 echo "variable and rerun configure."
804 else
805 echo "Warning: compilation may fail because you're using"
806 echo "/usr/ucb/cc, when you should use the C compiler from"
807 echo "$could_use. You should change your"
808 echo "PATH or CC variable and rerun configure."
809 fi
810 fi
811 ;;
812 esac
813
814 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
815 # binutils tools will find libbfd.so.
816 if [ "${shared}" = "yes" ]; then
817 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
818 Makefile > Makefile.tem
819 rm -f Makefile
820 mv -f Makefile.tem Makefile
821
822 case "${host}" in
823 *-*-hpux*)
824 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
825 Makefile > Makefile.tem
826 rm -f Makefile
827 mv -f Makefile.tem Makefile
828 ;;
829 esac
830 fi
831
832 # Record target_configdirs and the configure arguments in Makefile.
833 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
834 targargs=`echo "${arguments}" | \
835 sed -e 's/--norecursion//' \
836 -e 's/--cache[a-z-]*=[^ ]*//' \
837 -e 's/--ho[a-z-]*=[^ ]*//' \
838 -e 's/--ta[a-z-]*=[^ ]*//'`
839
840 # Passing a --with-cross-host argument lets the target libraries know
841 # whether they are being built with a cross-compiler or being built
842 # native. However, it would be better to use other mechanisms to make the
843 # sorts of decisions they want to make on this basis. Please consider
844 # this option to be deprecated. FIXME.
845 if [ x${is_cross_compiler} = xyes ]; then
846 targargs="--with-cross-host=${host_alias} ${targargs}"
847 fi
848
849 targargs="--host=${target_alias} ${targargs}"
850 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
851 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
852 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
853 Makefile > Makefile.tem
854 rm -f Makefile
855 mv -f Makefile.tem Makefile
856
857 #
858 # Local Variables:
859 # fill-column: 131
860 # End:
861 #
This page took 0.051463 seconds and 4 git commands to generate.